/*
 * video_in_dma.h
 *
 *  Created on: Apr 22, 2017
 *      Author: fb
 */

#ifndef VIDEO_IN_DMA_H_
#define VIDEO_IN_DMA_H_


/**
 * @brief Changes the back buffer's start address
 *
 * @param video_in_dma_base_address -- base address of the VIDEO DMA
 * @param new_address  -- the new start address of the back buffer
 *
 * @return 0 for success
 **/
int video_in_dma_change_back_buffer_address(unsigned int video_in_dma_base_address, unsigned int new_address);

/**
 * @brief Swaps which buffer is being written by the VIDEO DMA
 *
 * @param video_in_dma_base_address -- base address of the VIDEO_IN_DMA
 *
 * @return 0 for success
 **/
int video_in_dma_swap_buffers(unsigned int video_in_dma_base_address);

/**
 * @brief Check if swapping buffers has completed
 *
 * @param pixel_buffer -- video_in_dma_base_address -- base address of the VIDEO DMA
 *
 * @return 0 if complete, 1 if still processing
 **/
int video_in_dma_check_swap_buffers_status(unsigned int video_in_dma_base_address);


#endif /* VIDEO_IN_DMA_H_ */
